## mingw-w64-frontistr-5.5-2.src.tar.zst

=== CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

###############################################################
# CMakeLists.txt for FrontISTR
###############################################################
cmake_minimum_required(VERSION 2.8.11)

###############################################################
# Check building mode whether out-of-source builds
###############################################################
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "
*************** ERROR ***************
 Only support for out-of-source building.
 You may need to remove CMakeCache.txt file and CMakeFiles/ directory.
 Please make new directory such as build/ and run cmake in it again.
[example]
 rm CMakeCache.txt; rm -rf CMakeFiles/
 mkdir build/; cd build/
 cmake ..
 make")
endif()

project(FrontISTR Fortran C CXX)
###############################################################
# Includes standard macros
###############################################################
include(FeatureSummary)
include(CMakeDependentOption)
include(CMakeDetermineFortranCompiler)

###############################################################
# Add module path for FindPackage.cmake
###############################################################
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

###############################################################
# Initialize variable of definitions, link libraries, includes
###############################################################
set(FrontISTR_DEFINITIONS)
set(FrontISTR_LIBRARIES)
set(FrontISTR_INCLUDE_DIRS ${CMAKE_Fortran_MODULE_DIRECTORY} ${PROJECT_BINARY_DIR})

###############################################################
# Build type (RELEASE or DEBUG)
###############################################################
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RELEASE" CACHE STRING "Build type (RELEASE or DEBUG)" FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS RELEASE DEBUG)
endif()
if(CMAKE_BUILD_TYPE MATCHES "DEBUG")
  list(APPEND FrontISTR_DEFINITIONS "DEBUG")
  # Enable debug options
  find_package(Backtrace)
  if(Backtrace_FOUND)
    list(APPEND FrontISTR_LIBRARIES ${Backtrace_LIBRARY})
    list(APPEND FrontISTR_INCLUDE_DIR ${Backtrace_INCLUDE_DIR})
    set(CMAKE_VERBOSE_MAKEFILE ON)
    # GNU Compiler
    if(CMAKE_C_COMPILER_ID MATCHES "GNU")
      set(CMAKE_C_FLAGS_DEBUG
        "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra")
      set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra")
      set(CMAKE_Fortran_FLAGS_DEBUG
        "${CMAKE_Fortran_FLAGS_DEBUG} -Wall -Wextra -fbounds-check -fbacktrace")
      if(${DEBUG_EXTRA})
        set(CMAKE_C_FLAGS_DEBUG
          "${CMAKE_C_FLAGS_DEBUG} -fsanitize=address")
        set(CMAKE_CXX_FLAGS_DEBUG
          "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=address")
        set(CMAKE_Fortran_FLAGS_DEBUG
          "${CMAKE_Fortran_FLAGS_DEBUG} -fsanitize=address")
      endif()
    # Intel Compiler
    elseif(CMAKE_C_COMPILER_ID MATCHES "Intel")
      set(CMAKE_C_FLAGS_DEBUG
        "${CMAKE_C_FLAGS_DEBUG} -Wall -Wbrief -Wcheck")
      set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wbrief -Wcheck")
      set(CMAKE_Fortran_FLAGS_DEBUG
        #"${CMAKE_Fortran_FLAGS_DEBUG} -warn all -check all -traceback")
        "${CMAKE_Fortran_FLAGS_DEBUG} -warn nounused -check uninit,bound -traceback")
    endif()
  endif()
elseif (CMAKE_BUILD_TYPE MATCHES "RELEASE")
  list(APPEND FrontISTR_DEFINITIONS "NDEBUG")
endif()

###############################################################
# Version number
###############################################################
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

file(READ "VERSION" ver)
string(REGEX MATCH "[0-9](.[0-9](.[0-9])?)?" vertxt ${ver})
string(REGEX MATCHALL "[0-9]" verlist "${vertxt}")
list(LENGTH verlist verlength)
set(VERSION_MAJOR 0)
set(VERSION_MINOR 0)
set(VERSION_PATCH 0)
list(GET verlist 0 VERSION_MAJOR)
if(${verlength} GREATER 1)
  list(GET verlist 1 VERSION_MINOR)
endif()
if(${verlength} GREATER 2)
  list(GET verlist 2 VERSION_PATCH)
endif()
execute_process(COMMAND date "+%Y-%m-%dT%H:%M:%S%z" OUTPUT_VARIABLE BUILD_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
set(GIT_HASH \"${GIT_SHA1}\" CACHE STRING "GIT hash number of FrontISTR")
mark_as_advanced(VERSION_MAJOR VERSION_MINOR VERSION_PATCH BUILD_DATE GIT_HASH)

#############################################
# Architecture and compiler dependent options
#############################################
if(WIN32)
  set(WINDOWS TRUE)
endif()

###############################################################
# Options
###############################################################
# -DWINDOWS          : build on Windows
# -DWITH_TOOLS       : compile tools
# -DWITH_MPI         : for parallel environment with MPI
# -DWITH_OPENMP      : for multi-(core|processor) environment
# -DWITH_REFINER     : compile with REVOCAP_Refiner
# -DWITH_REVOCAP     : compile with REVOCAP_Coupler
# -DWITH_METIS       : compile with METIS graph partitioning package
#   -DMETIS_VER_4    : uses METIS-4
# -DWITH_PARMETIS    : compile with ParMETIS
#   -DPARMETIS_VER_3 : uses PARMETIS-3
# -DWITH_MKL         : compile with MKL PARDISO
# -DWITH_MUMPS       : compile with MUMPS direct solver
# -DWITH_LAPACK      : compile with LAPACK
# -DWITH_ML          : compile with Trilinos multigrid preconditioning package
# -DWITH_DOC         : generate API documents
# -DOLD_RES_FORMAT   : use old style result file( comment and global output disabled)

###################
# Find external packages
###################
option(WITH_MPI "for parallel environment with MPI" ON)
if(WITH_MPI)
  find_package(MPI)
  set(WITH_MPI "${MPI_FOUND}")
  find_package(Parmetis)
  find_package(Scalapack)
endif()
find_package(OpenMP)
find_package(MKL)
find_package(LAPACK)
find_package(Metis)
find_package(Mumps)
find_package(Refiner)
find_package(Revocap)
find_package(Trilinos)
find_package(Doxygen)
option(WITH_TOOLS "compile tools" ON)
option(WITH_DOC "Generate API documents." ${WITH_DOC})
option(WINDOWS "build on windows" ${WINDOWS})
option(WITH_OPENMP "for multi-(core|processor) environment" ${OPENMP_FOUND})
option(WITH_MKL "compile with MKL PARDISO" ${MKL_FOUND})
option(WITH_LAPACK "for estimating number of condition" ${LAPACK_FOUND})
option(WITH_METIS "compile with METIS" ${METIS_FOUND})
option(METIS_VER_4 "uses METIS-4" OFF)
option(WITH_MUMPS "compile with MUMPS direct solver" ${MUMPS_FOUND})
option(WITH_PARMETIS "compile with ParMETIS" ${PARMETIS_FOUND})
option(PARMETIS_VER_3 "uses METIS-3" OFF)
option(WITH_REFINER "compile with REVOCAP_Refiner" ${REFINER_FOUND})
option(WITH_REVOCAP "compile with REVOCAP_Coupler" ${REVOCAP_FOUND})
option(WITH_ML "compile with Trilinos ML" ${Trilinos_FOUND})
option(OLD_RES_FORMAT "use old style result file" ${OLD_RES_FORMAT})
option(DEBUG_EXTRA "enable memory leak check (only for gcc4.9 <)" OFF)
feature_summary(WHAT ALL)

# Provisional solution FOR GCC Fortran 10 compiling error
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 10)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
endif()

###################
# -DWITH_OPENMP
###################
if(WITH_OPENMP AND OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
else()
  set(WITH_OPENMP OFF)
endif()

###################
# -DWITH_MKL
###################
if(WITH_MKL)
  set(BLA_VENDOR "Intel10_64lp")
  list(APPEND FrontISTR_INCLUDE_DIRS ${MKL_INCLUDE_PATH})
  list(APPEND FrontISTR_LIBRARIES ${MKL_LIBRARIES})
  list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_MKL")
  set(WITH_LAPACK ON)
else()
  set(WITH_MKL OFF)
endif()

###################
# -DWITH_REFINER
###################
if(WITH_REFINER AND REFINER_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${REFINER_INCLUDE_PATH})
  list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_REFINER")
  list(APPEND FrontISTR_LIBRARIES ${REFINER_LIBRARIES})
else()
  set(WITH_REFINER OFF)
  set(HECMW_WITH_REFINER OFF)
endif()

###################
# -DWITH_REVOCAP
###################
if(WITH_REVOCAP AND REVOCAP_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${REVOCAP_INCLUDE_PATH})
else()
  set(WITH_REVOCAP OFF)
endif()

###################
# -DWITH_ML
###################
if(WITH_ML)
  if(Trilinos_FOUND)
    list(FIND Trilinos_TPL_LIST MPI trilinos_mpi_index)
    if((trilinos_mpi_index EQUAL -1 AND WITH_MPI) OR (trilinos_mpi_index GREATER -1 AND NOT WITH_MPI))
      message(WARNING "Trilinos found but turned off due to incompatible MPI setting")
      set(WITH_ML OFF)
    else()
      list(APPEND FrontISTR_INCLUDE_DIRS ${Trilinos_INCLUDE_DIRS} ${Trilinos_TPL_INCLUDE_DIRS})
      list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_ML")
      list(APPEND FrontISTR_LIBRARIES ${Trilinos_LIBRARIES} ${Trilinos_TPL_LIBRARIES})
    endif()
  else()
    message(WARNING "Trilinos not found")
    set(WITH_ML OFF)
  endif()
endif()
mark_as_advanced(Trilinos_DIR)

###################
# -DWITH_MUMPS
###################
if(WITH_MUMPS)
  if(MUMPS_FOUND)
    if(WITH_MPI)
      if((SCALAPACK_FOUND AND LAPACK_FOUND) OR SCALAPACK_MKL)
        list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_MUMPS")
        list(APPEND FrontISTR_INCLUDE_DIRS ${MUMPS_INCLUDE_PATH})
        list(APPEND FrontISTR_LIBRARIES ${MUMPS_LIBRARIES} ${SCALAPACK_LIBRARIES})
        mark_as_advanced(scalapack_DIR)
      else()
        message(WARNING "MUMPS could not be enabled. Please also install scalapack and lapack.")
        set(WITH_MUMPS OFF)
      endif()
    else()
      list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_MUMPS")
      list(APPEND FrontISTR_INCLUDE_DIRS ${MUMPS_INCLUDE_PATH})
      list(APPEND FrontISTR_LIBRARIES ${MUMPS_LIBRARIES})
    endif()
  else()
    message(WARNING "MUMPS not found")
    set(WITH_MUMPS OFF)
  endif()
endif()

###################
# -DWITH_PARMETIS
###################
if(WITH_PARMETIS AND PARMETIS_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${PARMETIS_INCLUDE_PATH})
  list(APPEND FrontISTR_LIBRARIES ${PARMETIS_LIBRARIES})
  if(NOT PARMETIS_VER_3)
  else()
  endif()
endif()

###################
# -DWITH_METIS
# -DMETIS_VER_4
###################
if(WITH_METIS AND METIS_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${METIS_INCLUDE_PATH})
  list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_METIS")
  list(APPEND FrontISTR_DEFINITIONS "HECMW_PART_WITH_METIS")
  list(APPEND FrontISTR_LIBRARIES ${METIS_LIBRARIES})
  if(NOT METIS_VER_4)
    list(APPEND FrontISTR_DEFINITIONS "HECMW_METIS_VER=5")
  else()
    list(APPEND FrontISTR_DEFINITIONS "HECMW_METIS_VER=4")
  endif()
endif()

###################
# -DWITH_LAPACK
###################
if(WITH_LAPACK)
  if(LAPACK_FOUND AND BLAS_FOUND)
    list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_LAPACK")
    list(APPEND FrontISTR_LIBRARIES ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
  else()
    set(WITH_LAPACK OFF)
  endif()
endif()


###################
# -DOLD_RES_FORMAT
###################
if(OLD_RES_FORMAT)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DOLD_RES_FORMAT")
endif()

###################
# -DWITH_MPI
###################
if(WITH_MPI AND MPI_Fortran_FOUND AND MPI_CXX_FOUND AND MPI_C_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS
    ${MPI_C_INCLUDE_PATH}
    ${MPI_CXX_INCLUDE_PATH}
    ${MPI_Fortran_INCLUDE_PATH})

  list(APPEND FrontISTR_LIBRARIES
    ${MPI_C_LIBRARIES}
    ${MPI_CXX_LIBRARIES}
    ${MPI_Fortran_LIBRARIES})

else()
  set(WITH_MPI OFF)
  set(HECMW_SERIAL ON)

=== hecmw1/tools/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

#
# Build executable hec2rcap
#
set(hec2rcap_SOURCES)
include(hec2rcap/CMakeLists.txt)
add_executable(hec2rcap ${hec2rcap_SORUCES})
set_target_properties(hec2rcap PROPERTIES LINKER_LANGUAGE "CXX")
target_link_libraries(hec2rcap hecmw ${hecmw_LIBRARIES})
target_include_directories(hec2rcap PUBLIC ${hecmw_INCLUDE_DIRS})
target_compile_definitions(hec2rcap PUBLIC ${hecmw_DEFINITIONS})

#
# Build executable hecmw_part1
#
set(hecmw_part1_SOURCES)
include(partitioner/CMakeLists.txt)
add_executable(hecmw_part1 ${hecmw_part1_SOURCES})
set_target_properties(hecmw_part1 PROPERTIES LINKER_LANGUAGE "CXX")
target_link_libraries(hecmw_part1 hecmw ${hecmw_LIBRARIES})
target_include_directories(hecmw_part1 PUBLIC ${hecmw_INCLUDE_DIRS})
target_compile_definitions(hecmw_part1 PUBLIC ${hecmw_DEFINITIONS})

#
# Build executable rmerge
#
set(rmerge_SOURCES)
include(result_file_merger/CMakeLists.txt)
add_executable(rmerge ${rmerge_SOURCES})
set_target_properties(rmerge PROPERTIES LINKER_LANGUAGE "CXX")
target_link_libraries(rmerge hecmw ${hecmw_LIBRARIES})
target_include_directories(rmerge PUBLIC ${hecmw_INCLUDE_DIRS})
target_compile_definitions(rmerge PUBLIC ${hecmw_DEFINITIONS})

#
# Build executable rconv
#
set(rconv_SOURCES)
include(result_type_converter/CMakeLists.txt)
add_executable(rconv ${rconv_SOURCES})
set_target_properties(rconv PROPERTIES LINKER_LANGUAGE "CXX")
target_link_libraries(rconv hecmw ${hecmw_LIBRARIES})
target_include_directories(rconv PUBLIC ${hecmw_INCLUDE_DIRS})
target_compile_definitions(rconv PUBLIC ${hecmw_DEFINITIONS})

#
# Build executable hecmw_vis1
#
set(hecmw_vis1_SOURCES)
include(visualizer/CMakeLists.txt)
add_executable(hecmw_vis1 ${hecmw_vis1_SOURCES})
set_target_properties(hecmw_vis1 PROPERTIES LINKER_LANGUAGE "CXX")
target_link_libraries(hecmw_vis1 hecmw ${hecmw_LIBRARIES})
target_include_directories(hecmw_vis1 PUBLIC ${hecmw_INCLUDE_DIRS})
target_compile_definitions(hecmw_vis1 PUBLIC ${hecmw_DEFINITIONS})

#
# Set installing files
#
install(TARGETS hec2rcap hecmw_part1 rmerge rconv hecmw_vis1
  DESTINATION bin
  CONFIGURATIONS ${CMAKE_BUILD_TYPE}
)

=== hecmw1/src/hecmw/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw.f90
)

list(APPEND hecmw_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== hecmw1/tools/result_file_merger/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND rmerge_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/fstr_rmerge_util.c
  ${CMAKE_CURRENT_LIST_DIR}/fstr_rmerge.c
)

=== docker/binary/x86_64-w64-mingw32/hybrid/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
REGISTRY_IMAGE     ?= $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/hybrid

build: build_msmpi build_impi
build_msmpi: build_msmpi_openblas build_msmpi_mkl
build_msmpi_openblas:
	docker build -t $(REGISTRY_IMAGE):msmpi_openblas            -f Dockerfile.msmpi . --target openblas
	docker build -t $(REGISTRY_IMAGE):msmpi_openblas_trilinos12 -f Dockerfile.msmpi . --target openblas-trilinos12
	docker build -t $(REGISTRY_IMAGE):msmpi_openblas_metis4     -f Dockerfile.msmpi . --target openblas-metis4
build_msmpi_mkl:
	docker build -t $(REGISTRY_IMAGE):msmpi_mkl                 -f Dockerfile.msmpi . --target mkl
	docker build -t $(REGISTRY_IMAGE):msmpi_mkl_trilinos12      -f Dockerfile.msmpi . --target mkl-trilinos12
	docker build -t $(REGISTRY_IMAGE):msmpi_mkl_metis4          -f Dockerfile.msmpi . --target mkl-metis4
build_impi: build_impi_openblas build_impi_mkl
build_impi_openblas:
	docker build -t $(REGISTRY_IMAGE):impi_openblas             -f Dockerfile.impi  . --target openblas
	docker build -t $(REGISTRY_IMAGE):impi_openblas_trilinos12  -f Dockerfile.impi  . --target openblas-trilinos12
	docker build -t $(REGISTRY_IMAGE):impi_openblas_metis4      -f Dockerfile.impi  . --target openblas-metis4
build_impi_mkl:
	docker build -t $(REGISTRY_IMAGE):impi_mkl                  -f Dockerfile.impi  . --target mkl
	docker build -t $(REGISTRY_IMAGE):impi_mkl_trilinos12       -f Dockerfile.impi  . --target mkl-trilinos12
	docker build -t $(REGISTRY_IMAGE):impi_mkl_metis4           -f Dockerfile.impi  . --target mkl-metis4

push: push_msmpi push_impi
push_msmpi:  push_msmpi_openblas push_msmpi_mkl
push_msmpi_openblas: build_msmpi_openblas
	docker push $(REGISTRY_IMAGE):msmpi_openblas
	docker push $(REGISTRY_IMAGE):msmpi_openblas_trilinos12
	docker push $(REGISTRY_IMAGE):msmpi_openblas_metis4
push_msmpi_mkl: build_msmpi_mkl
	docker push $(REGISTRY_IMAGE):msmpi_mkl
	docker push $(REGISTRY_IMAGE):msmpi_mkl_trilinos12
	docker push $(REGISTRY_IMAGE):msmpi_mkl_metis4
push_impi:  push_impi_openblas push_impi_mkl
push_impi_openblas: build_impi_openblas
	docker push $(REGISTRY_IMAGE):impi_openblas
	docker push $(REGISTRY_IMAGE):impi_openblas_trilinos12
	docker push $(REGISTRY_IMAGE):impi_openblas_metis4
push_impi_mkl: build_impi_mkl
	docker push $(REGISTRY_IMAGE):impi_mkl
	docker push $(REGISTRY_IMAGE):impi_mkl_trilinos12
	docker push $(REGISTRY_IMAGE):impi_mkl_metis4

=== docker/binary/x86_64-w64-mingw32/thread/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
REGISTRY_IMAGE     ?= $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/thread

build: build_openblas build_mkl
build_openblas:
	docker build -t $(REGISTRY_IMAGE):openblas            -f Dockerfile . --target openblas
	docker build -t $(REGISTRY_IMAGE):openblas_trilinos12 -f Dockerfile . --target openblas-trilinos12
	docker build -t $(REGISTRY_IMAGE):openblas_metis4     -f Dockerfile . --target openblas-metis4
build_mkl:
	docker build -t $(REGISTRY_IMAGE):mkl                 -f Dockerfile . --target mkl
	docker build -t $(REGISTRY_IMAGE):mkl_trilinos12      -f Dockerfile . --target mkl-trilinos12
	docker build -t $(REGISTRY_IMAGE):mkl_metis4          -f Dockerfile . --target mkl-metis4

push: push_openblas push_mkl
push_openblas: build_openblas
	docker push $(REGISTRY_IMAGE):openblas
	docker push $(REGISTRY_IMAGE):openblas_trilinos12
	docker push $(REGISTRY_IMAGE):openblas_metis4
push_mkl: build_mkl
	docker push $(REGISTRY_IMAGE):mkl
	docker push $(REGISTRY_IMAGE):mkl_trilinos12
	docker push $(REGISTRY_IMAGE):mkl_metis4

=== fistr1/src/analysis/heat/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/heat_init.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_io.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_get_amplitude.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_echo.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_bc_CFLUX.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_bc_DFLUX.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_bc_FILM.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_bc_FIXT.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_bc_RADIATE.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_boundary.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_capacity.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_mat_ass_conductivity.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_solve_main.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_solve_TRAN.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_solve_heat.f90
)

=== fistr1/src/lib/element/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/element.f90
  ${CMAKE_CURRENT_LIST_DIR}/hex20n.f90
  ${CMAKE_CURRENT_LIST_DIR}/hex8n.f90
  ${CMAKE_CURRENT_LIST_DIR}/line2n.f90
  ${CMAKE_CURRENT_LIST_DIR}/line3n.f90
  ${CMAKE_CURRENT_LIST_DIR}/prism15n.f90
  ${CMAKE_CURRENT_LIST_DIR}/prism6n.f90
  ${CMAKE_CURRENT_LIST_DIR}/quad4n.f90
  ${CMAKE_CURRENT_LIST_DIR}/quad8n.f90
  ${CMAKE_CURRENT_LIST_DIR}/quad9n.f90
  ${CMAKE_CURRENT_LIST_DIR}/quadrature.f90
  ${CMAKE_CURRENT_LIST_DIR}/tet10n.f90
  ${CMAKE_CURRENT_LIST_DIR}/tet4n.f90
  ${CMAKE_CURRENT_LIST_DIR}/tri3n.f90
  ${CMAKE_CURRENT_LIST_DIR}/tri6n.f90
)

=== fistr1/src/lib/utilities/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/ttable.f90
  ${CMAKE_CURRENT_LIST_DIR}/utilities.f90
)

=== fistr1/tools/neu2fstr/NFD/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND neu2fstr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/CNFData.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_100.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_402.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_403.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_404.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_405.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_408.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_506.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_507.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFDB_601.cpp
  ${CMAKE_CURRENT_LIST_DIR}/CNFMessage.cpp
)

list(APPEND neu2fstr_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== hecmw1/src/operations/adaptation/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_int_sr.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_int_sr_rev.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_item_sr.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_real_sr.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_stack_sr.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_active.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_adjemb.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_bc_pointer.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_cell_comm_table.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_edge_comm_table.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_edge_info.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_error_exit.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_extemb.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_get_new_cell_info.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_grid_smooth.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_allocate.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_new_cell_341.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_new_cell_351.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_new_cell.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_new_node.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_new_mesh.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_repro_comm_table.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_init.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_adapt_proc.f90
)

=== hecmw1/src/solver/solver_direct_lag/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/my_hecmw_util_f_lag.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_irjc_matrix_lag.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_child_matrix_lag.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_crs_matrix_lag.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_solver_direct_serial_lag.f90
)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=frontistr
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.5
pkgrel=2
pkgdesc='Open-Source Large-Scale Parallel FEM Program for Nonlinear Structural Analysis (mingw-w64)'
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-parmetis"
         "${MINGW_PACKAGE_PREFIX}-metis"
         "${MINGW_PACKAGE_PREFIX}-msmpi"
         # "${MINGW_PACKAGE_PREFIX}-mumps" Couldn't be found by cmake!
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-seacas"
         "${MINGW_PACKAGE_PREFIX}-trilinos"
         "${MINGW_PACKAGE_PREFIX}-doxygen"
         "${MINGW_PACKAGE_PREFIX}-scalapack"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
license=('MIT')
url="https://www.frontistr.com"
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}.tar.gz")
sha256sums=('d4fb213d7b57ad84dca96949c6ece0d8a4499e4a2dd2deb2d038a2e605bf6005')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS="-fallow-invalid-boz"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      ${_extra_config[@]} \
      -DWITH_MPI=ON \
      -DWITH_ML=ON \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
  
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} cmake --install .
  install -Dm644 ${srcdir}/${_realname}-${pkgver}/License.txt ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE 

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in $(find "${pkgdir}${MINGW_PREFIX}"/lib/cmake -type f); do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done
  
}
